import Fragment from './fragment.glsl'
import Vertex from './vertex.glsl'
import * as THREE from 'three';
import SketchBase from '../base';

export default class Sketch extends SketchBase {
  constructor(el) {
    super(el);
    this.addBox();
    this.render();
  }
  addBox() {
    let plane = new THREE.PlaneGeometry(50, 50);
    let material = new THREE.ShaderMaterial({
      side: THREE.DoubleSide,
      uniforms: {
        uTime: {
          value: 0
        },
      },
      depthWrite: false,
      depthTest: false,
      vertexShader: Vertex,
      fragmentShader: Fragment,
    });
    let mesh = new THREE.Mesh(plane, material);
    this.scene.add(mesh);
  }
}
