import Fragment from './fragment.glsl'
import Vertex from './vertex.glsl'
import * as THREE from 'three';
import SketchBase from '../base';
/**

 */


export default class Sketch extends SketchBase {
  constructor(el) {
    super(el);
    this.addBox();
    this.anime();
  }
  addBox() {
    let uniforms = {
      uTime: {
        type: "f",
        value: 1.0
      },
      u_resolution: {
        type: "v2",
        value: new THREE.Vector2()
      }
    };
    let plane = new THREE.PlaneGeometry(50, 50);
    let material = new THREE.ShaderMaterial({
      side: THREE.DoubleSide,
      uniforms,
      vertexShader: Vertex,
      fragmentShader: Fragment,
    });
    uniforms.u_resolution.value.x = this.renderer.domElement.width;
    uniforms.u_resolution.value.y = this.renderer.domElement.height;
    this.box = new THREE.Mesh(plane, material);
    this.scene.add(this.box);
  }
  anime() {
    this.index = window.requestAnimationFrame(this.anime.bind(this));
    this.box.material.uniforms.uTime.value += 0.01;
    this.render();
  }
}
