import { defineConfig } from "vite";
import vue from "@vitejs/plugin-vue";
import path from "path";
import glsl from "vite-plugin-glsl";

const nodeResolve = (dir) => path.resolve(__dirname, ".", dir);
// https://vitejs.dev/config/
export default defineConfig({
  server: {
    host: "0.0.0.0",
  },
  plugins: [vue(), glsl()],
  resolve: {
    alias: {
      "@": nodeResolve("src"),
      "~": nodeResolve("public"),
    },
  },
});
